package com.eactive.eai.custom.adapter.http.client.impl;

import java.util.Properties;

import org.apache.commons.lang3.StringUtils;
import org.dom4j.Node;
import org.json.simple.JSONObject;

import com.eactive.eai.adapter.http.client.HttpClientAdapterServiceKey;
import com.eactive.eai.adapter.http.client.impl.filter.HttpClient5AdapterFilterFactory;
import com.eactive.eai.adapter.http.client.impl.filter.HttpClientAdapterFilter;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.node.ObjectNode;

/**
 * 1. 기능 : HttpClient5AdapterServiceRest 호출 전후 Filter 적용할 수 있는 기능을 제공한다.<br>
 * 2. 처리 개요 : <br>
 * 3. 주의사항 <br>
 *
 * @author :
 * @version : v 1.0.0
 * @see : HttpClientAdapterServiceFactory.java,
 *      HttpClientAdapterServiceSupport.java, HttpClient5AdapterServiceRest.java
 * @since :
 * 
 */
public class HttpClient5AdapterServiceBigTechAddFilter extends HttpClient5AdapterServiceBigTech
		implements HttpClientAdapterServiceKey {

	// 요청전 수행할 필터(쉼표(,)로 구분)
	static final String PRE_FILTERS = "PRE_FILTERS";

	// 요청후 수행할 필터(쉼표(,)로 구분)
	static final String POST_FILTERS = "POST_FILTERS";

//	// Adapter에서 Exception이 발생한 경우, 처리할 필터
//	static final String EXCEPTION_FILTER = "EXCEPTION_FILTER";

	private ObjectMapper mapper = new ObjectMapper();
	
	/**
	 * 1. 기능 : HttpClient 호출 전후 Filter 적용용 2. 처리 개요 : <br>
	 * 3. 주의사항 <br>
	 *
	 * @param prop Http Adapter 속성 정보
	 * @return 반환 된 Object
	 * @exception Exception 수동 시스템 간 통신 중 발생
	 */
	public Object execute(Properties prop, Object data, Properties tempProp) throws Exception {

		String adptGrpName = tempProp.getProperty(ADAPTER_GROUP_NAME);
		String adptName = tempProp.getProperty(ADAPTER_NAME);

		data = doPreFilters(adptGrpName, adptName, prop, data, tempProp);

		Object adapterResponse = super.execute(prop, data, tempProp);

		adapterResponse = doPostFilters(adptGrpName, adptName, prop, adapterResponse, tempProp);
		if (adapterResponse instanceof JSONObject)
			adapterResponse = ((JSONObject) adapterResponse).toJSONString();
		else if (adapterResponse instanceof ObjectNode)
			adapterResponse = mapper.writeValueAsString((ObjectNode) adapterResponse);
		else if (adapterResponse instanceof Node)
			adapterResponse = ((Node) adapterResponse).asXML();

		return adapterResponse;
	}

	protected Object doPreFilters(String adptGrpName, String adptName, Properties prop, Object message,
			Properties tempProp) throws Exception {

//		boolean isSetCommonFilterInAdapterProp = false;
		// 1. adapter에 설정된 필터 수행
		String preFiltersStr = prop.getProperty(PRE_FILTERS);
		if (StringUtils.isNotEmpty(preFiltersStr)) {
			String[] preFilters = StringUtils.split(preFiltersStr, ",");
			for (String filterName : preFilters) {
				if (StringUtils.isBlank(filterName)) {
					continue;
				}

				logger.debug("HttpClient5AdapterServiceRestAddFilter] Processing Start [" + filterName + "]");
				HttpClientAdapterFilter adapterFilter = HttpClient5AdapterFilterFactory.createFilter(filterName.trim());

				if (adapterFilter != null) {
//					if (adapterFilter instanceof IBKOutCommonFilter)
//						isSetCommonFilterInAdapterProp = true;

					message = adapterFilter.doPreFilter(adptGrpName, adptName, prop, message, tempProp);
				} else {
					throw new Exception("Failed get Filter Class: " + filterName);
				}
			}
		}

//		// 2. IBKOutCommonFilter 필터 수행(adapter 필터에서 수행하지 않을 때만)
//		if (!isSetCommonFilterInAdapterProp) {
//			HttpClientAdapterFilter ibkFilter = HttpClient5AdapterFilterFactory
//					.createFilter(IBKOutCommonFilter.class.getName());
//			if (ibkFilter != null) {
//				message = ibkFilter.doPreFilter(adptGrpName, adptName, prop, message, tempProp);
//			}
//		} else {
//			logger.debug("IBKOutCommonFilter isSetCommonFilterInAdapterProp 'POST_FILTERS'. already in adapter filters");
//		}

		return message;
	}

	protected Object doPostFilters(String adptGrpName, String adptName, Properties prop, Object message,
			Properties tempProp) throws Exception {

//		boolean isSetCommonFilterInAdapterProp = false;
		// 1. adapter에 설정된 필터 수행
		String postFiltersStr = prop.getProperty(POST_FILTERS);
		if (StringUtils.isNotEmpty(postFiltersStr)) {
			String[] postFilters = StringUtils.split(postFiltersStr, ",");
			for (String filterName : postFilters) {
				if (StringUtils.isBlank(filterName)) {
					continue;
				}

				HttpClientAdapterFilter adapterFilter = HttpClient5AdapterFilterFactory.createFilter(filterName.trim());
				if (adapterFilter != null) {
//					if (adapterFilter instanceof IBKOutCommonFilter)
//						isSetCommonFilterInAdapterProp = true;
					message = adapterFilter.doPostFilter(adptGrpName, adptName, prop, message, tempProp);
				} else {
					throw new Exception("Failed get Filter Class: " + filterName);
				}
			}
		}

//		// 2. IBKOutCommonFilter 필터 수행
//		if (!isSetCommonFilterInAdapterProp) {
//			HttpClientAdapterFilter ibkFilter = HttpClient5AdapterFilterFactory
//					.createFilter(IBKOutCommonFilter.class.getName());
//			if (ibkFilter != null) {
//				message = ibkFilter.doPostFilter(adptGrpName, adptName, prop, message, tempProp);
//			}
//		} else {
//			logger.debug("IBKOutCommonFilter isSetCommonFilterInAdapterProp 'PRE_FILTERS'. already in adapter filters");
//		}
		return message;
	}

}